"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var event_source_1 = require("./event-source");
var state_emitter_1 = require("./state-emitter");
var metadata_1 = require("./metadata");
/** @ClassDecoratorFactory */
function Reactive() {
    return function (constructor) {
        // Create a proxy constructor for the target class that bootstraps all EventSource and StateEmitter properties per-instance
        var bootstrapConstructor = function $$ReactiveBootstrapped() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            // Perform bootstrap initialization
            event_source_1.EventSource.Bootstrap(this);
            state_emitter_1.StateEmitter.Bootstrap(this);
            // Apply the original constructor
            return constructor.apply(this, args);
        };
        // Assign the target ctor's prototype chain and data to the new constructor
        bootstrapConstructor.prototype = constructor.prototype;
        Object.setPrototypeOf(bootstrapConstructor, Object.getPrototypeOf(constructor));
        // Copy all existing metadata from the target class constructor to the new constructor
        metadata_1.Metadata.GetAllMetadata(constructor).forEach(function (value, key) { return metadata_1.Metadata.SetMetadata(key, bootstrapConstructor, value); });
        // Return the new constructor
        return bootstrapConstructor;
    };
}
exports.Reactive = Reactive;
