import { EventType } from "./event-metadata";
export declare type AngularLifecycleType = keyof {
    ngOnChanges;
    ngOnInit;
    ngOnDestroy;
    ngDoCheck;
    ngAfterContentInit;
    ngAfterContentChecked;
    ngAfterViewInit;
    ngAfterViewChecked;
};
export declare namespace AngularLifecycleType {
    type DecoratorFactory = () => PropertyDecorator;
    const OnChanges: AngularLifecycleType;
    const OnInit: AngularLifecycleType;
    const OnDestroy: AngularLifecycleType;
    const DoCheck: AngularLifecycleType;
    const AfterContentInit: AngularLifecycleType;
    const AfterContentChecked: AngularLifecycleType;
    const AfterViewInit: AngularLifecycleType;
    const AfterViewChecked: AngularLifecycleType;
    const values: AngularLifecycleType[];
    /** @PropertyDecoratorMetaFactory */
    function DecoratorFactory(type: EventType): DecoratorFactory;
}
/** @PropertyDecoratorFactory */
export declare const OnChanges: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const OnInit: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const OnDestroy: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const DoCheck: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const AfterContentInit: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const AfterContentChecked: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const AfterViewInit: AngularLifecycleType.DecoratorFactory;
/** @PropertyDecoratorFactory */
export declare const AfterViewChecked: AngularLifecycleType.DecoratorFactory;
