"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var event_source_1 = require("./event-source");
var AngularLifecycleType;
(function (AngularLifecycleType) {
    AngularLifecycleType.OnChanges = "ngOnChanges";
    AngularLifecycleType.OnInit = "ngOnInit";
    AngularLifecycleType.OnDestroy = "ngOnDestroy";
    AngularLifecycleType.DoCheck = "ngDoCheck";
    AngularLifecycleType.AfterContentInit = "ngAfterContentInit";
    AngularLifecycleType.AfterContentChecked = "ngAfterContentChecked";
    AngularLifecycleType.AfterViewInit = "ngAfterViewInit";
    AngularLifecycleType.AfterViewChecked = "ngAfterViewChecked";
    AngularLifecycleType.values = [
        AngularLifecycleType.OnChanges,
        AngularLifecycleType.OnInit,
        AngularLifecycleType.OnDestroy,
        AngularLifecycleType.DoCheck,
        AngularLifecycleType.AfterContentInit,
        AngularLifecycleType.AfterContentChecked,
        AngularLifecycleType.AfterViewInit,
        AngularLifecycleType.AfterViewChecked
    ];
    /** @PropertyDecoratorMetaFactory */
    function DecoratorFactory(type) {
        return function () {
            return event_source_1.EventSource(type);
        };
    }
    AngularLifecycleType.DecoratorFactory = DecoratorFactory;
})(AngularLifecycleType = exports.AngularLifecycleType || (exports.AngularLifecycleType = {}));
/** @PropertyDecoratorFactory */
exports.OnChanges = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.OnChanges);
/** @PropertyDecoratorFactory */
exports.OnInit = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.OnInit);
/** @PropertyDecoratorFactory */
exports.OnDestroy = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.OnDestroy);
/** @PropertyDecoratorFactory */
exports.DoCheck = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.DoCheck);
/** @PropertyDecoratorFactory */
exports.AfterContentInit = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.DoCheck);
/** @PropertyDecoratorFactory */
exports.AfterContentChecked = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.DoCheck);
/** @PropertyDecoratorFactory */
exports.AfterViewInit = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.DoCheck);
/** @PropertyDecoratorFactory */
exports.AfterViewChecked = AngularLifecycleType.DecoratorFactory(AngularLifecycleType.DoCheck);
