"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Metadata;
(function (Metadata) {
    function SetMetadata(symbol, target, value) {
        Reflect.defineMetadata(symbol, value, target);
    }
    Metadata.SetMetadata = SetMetadata;
    function GetMetadata(symbol, target, defaultValue) {
        if (!Reflect.hasMetadata(symbol, target)) {
            SetMetadata(symbol, target, defaultValue);
        }
        return Reflect.getOwnMetadata(symbol, target) || Reflect.getMetadata(symbol, target);
    }
    Metadata.GetMetadata = GetMetadata;
    function GetOwnMetadata(symbol, target, defaultValue) {
        if (!Reflect.hasOwnMetadata(symbol, target)) {
            SetMetadata(symbol, target, defaultValue);
        }
        return Reflect.getOwnMetadata(symbol, target);
    }
    Metadata.GetOwnMetadata = GetOwnMetadata;
    function GetAllMetadata(target) {
        return (Reflect.getMetadataKeys(target) || [])
            .reduce(function (map, key) { return map.set(key, Reflect.getMetadata(key, target)); }, new Map());
    }
    Metadata.GetAllMetadata = GetAllMetadata;
    function HasMetadata(symbol, target) {
        return Reflect.hasMetadata(symbol, target);
    }
    Metadata.HasMetadata = HasMetadata;
    function HasOwnMetadata(symbol, target) {
        return Reflect.hasOwnMetadata(symbol, target);
    }
    Metadata.HasOwnMetadata = HasOwnMetadata;
    function GetMetadataMap(symbol, target) {
        return GetMetadata(symbol, target, new Map());
    }
    Metadata.GetMetadataMap = GetMetadataMap;
    function GetOwnMetadataMap(symbol, target) {
        return GetOwnMetadata(symbol, target, new Map());
    }
    Metadata.GetOwnMetadataMap = GetOwnMetadataMap;
})(Metadata = exports.Metadata || (exports.Metadata = {}));
